//------------------------------------------------------------------------------
//
//  npengine.c
//  ANTZ application based on NPE
//
//  Created by Shane Saxon on 2/19/10.
//  Copyright Saxon Digital 2010. All rights reserved.
//
//------------------------------------------------------------------------------

#include "npengine.h"

#include "../npdata.h"
#include "../data/npplot.h"



void UpdatePlot (NPplotPtr plot);

//------------------------------------------------------------------------------
void npInitEngine (void* dataRef)
{

}


//------------------------------------------------------------------------------
void npCloseEngine (void* dataRef)
{

}


// iterate through plots update translation rotation and scale
//------------------------------------------------------------------------------
void npEngineUpdate (void* dataRef)
{
	int i = 0;

	pData data = (pData) dataRef;

	for (i=0; i < data->map.plotCount; i++)
	{
		UpdatePlot (data->map.plot[i]);
	}
}


//------------------------------------------------------------------------------
void UpdatePlot (NPplotPtr plot)
{

	// update rotation about XYZ axis and keep inbounds of 2X PI
	plot->rotateRad.x += plot->rotateRate.x;
	if (plot->rotateRate.x >= kPos2PI)
		plot->rotateRate.x -= kPos2PI;
	if (plot->rotateRate.x <= kNeg2PI)
		plot->rotateRate.x += kPos2PI;

	plot->rotateRad.y += plot->rotateRate.y;
	if (plot->rotateRate.y >= kPos2PI)
		plot->rotateRate.y -= kPos2PI;
	if (plot->rotateRate.y <= kNeg2PI)
		plot->rotateRate.y += kPos2PI;

	plot->rotateRad.z += plot->rotateRate.z;
	if (plot->rotateRate.z >= kPos2PI)
		plot->rotateRate.z -= kPos2PI;
	if (plot->rotateRate.z <= kNeg2PI)
		plot->rotateRate.z += kPos2PI;

	// calculate the rotation vector
	plot->rotate.x = (float)sin(plot->rotateRad.z) * (float)-cos(plot->rotateRad.x);
	plot->rotate.y = (float)-cos(plot->rotateRad.z) * (float)-cos(plot->rotateRad.x);
	plot->rotate.z = (float)sin(plot->rotateRad.x);

	// update XYZ scale
	plot->scale.x += plot->scaleRate.x;
	plot->scale.y += plot->scaleRate.y;
	plot->scale.z += plot->scaleRate.z;
	

	// update the translateVect for selected objects
	// http://www.math.utah.edu/~palais/bob/Rotation/Rotation.html
	// If (1,0) is rotated about the origin to (a,b), then (x,y) is rotated to  
	// (ax-by, bx+ay)

	plot->translateVect.x = (  plot->rotate.x * plot->translateRate.z
							 - plot->rotate.z * plot->translateRate.x )
							 / (1.00001f - plot->rotate.y);

	plot->translateVect.z = (  plot->rotate.z * plot->translateRate.z
							 + plot->rotate.x * plot->translateRate.x )
							 / (1.00001f - plot->rotate.y);

	// we ignore the angle for y movement just move in global coordinates
	plot->translateVect.y = plot->translateRate.y;


	plot->translate.x	+= plot->translateVect.x;
	plot->translate.y	+= plot->translateVect.y;
	plot->translate.z	+= plot->translateVect.z;

	if (plot->translate.y < 2.0f)											// debug, zz
		plot->translate.y = 2.0f;
}

